unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GameGridClass, TetrisGameClass, StdCtrls, ExtCtrls, Buttons;

type
  TFormMain = class(TForm)
    PanelTitle: TPanel;
    PanelMain: TPanel;
    sbPlay: TSpeedButton;
    sbPause: TSpeedButton;
    LabelScore: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure sbPauseClick(Sender: TObject);
    procedure sbPlayClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DeleteRowEvent (Sender: TObject);
    procedure FailedEvent (Sender: TObject);
  private
    { Private declarations }
    fTetris: TTetrisGame;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.FormCreate(Sender: TObject);
begin
  fTetris := TTetrisGame.Create (Self);
  fTetris.Parent := PanelMain;
  fTetris.Speed := 500;
  fTetris.Left := GetSystemMetrics (SM_CXBORDER);
  fTetris.Top := GetSystemMetrics (SM_CYBORDER);
  fTetris.OnDeleteRow := DeleteRowEvent;
  fTetris.OnFailed := FailedEvent;
  PanelMain.Width := fTetris.Width + GetSystemMetrics (SM_CXBORDER) * 2;
  PanelMain.Height := fTetris.Height + GetSystemMetrics (SM_CYBORDER) * 2;
  PanelTitle.Width := PanelMain.Width;
  AutoSize := TRUE;
end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
//  if fTetris.State <> gsPaused then
//    fTetris.Prepare;
  fTetris.Play;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  fTetris.Stop;
  Action := caFree;
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  fTetris.Pause;
end;

procedure TFormMain.Button3Click(Sender: TObject);
begin
  fTetris.FigureLeft;
end;

procedure TFormMain.Button4Click(Sender: TObject);
begin
  fTetris.FigureRight;
end;

procedure TFormMain.sbPauseClick(Sender: TObject);
begin
  sbPause.Down := not sbPause.Down;
  if sbPause.Down then
    fTetris.Pause
  else
    fTetris.Play;
end;

procedure TFormMain.sbPlayClick(Sender: TObject);
begin
  fTetris.Prepare;
  fTetris.Play;
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RETURN: begin
      sbPause.Down := FALSE;
      fTetris.Play;
    end;
    VK_SPACE: sbPause.Click;
    VK_LEFT: fTetris.FigureLeft;
    VK_RIGHT: fTetris.FigureRight;
    VK_DOWN: fTetris.Drop;
    VK_UP: fTetris.Rotate;
  end;
end;

procedure TFormMain.DeleteRowEvent(Sender: TObject);
begin
  LabelScore.Caption := IntToStr (fTetris.Score);
end;

procedure TFormMain.FailedEvent(Sender: TObject);
begin
  ShowMessage ('You loose!');
end;

end.
